/*$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$*/
/*$$$$$                       myplot.hh                               $$$$$*/
/*$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$*/

/****************************************************************************

  CVS information:

  $Id: PGmyplot.h,v 1.10 2002/09/11 12:04:09 wilcke Exp $

****************************************************************************/

/*
Update 11/09/2002 R. Wilcke (wilcke@esrf.fr)
                  really renamed getPlotcursorPoints() to getPlotcursorPoint().
Update 16/04/2002 O. Svensson (svensson@esrf.fr)
                  Renamed getPlotcursorPoints to getPlotcursorPoint,
                  changed the arguments.
Update 21/09/2001 O. Svensson (svensson@esrf.fr)
                  Moved declarations of META_DEVICE, HC_DEVICE,
                  X_DEVICE, PS_DEVICE, PLOT_DEV, PLOT_CURSORNPOINTS
                  and PLOT_CURSORPOINTS to PGmyplot.c
Update 09/11/2000 O. Svensson (svensson@esrf.fr)
                  Added function headers for pushconfig() and popconfig().
Update 03/10/2000 O. Svensson (svensson@esrf.fr)
                  Added a new cursor input method which stores the selected
                  points in a global variable PLOT_CURSORPOINTS.
*/

#ifndef _PGMYPLOT_H_
#define _PGMYPLOT_H_

/* #define GRAPHIC */		/* The GraphiC package is being used */

/* #define PGPLOT */ /* PGPLOT now defined in Makefile */
#include <cpgplot.h>

/* #define PGMETA */

#define PLOT_CURSORMAXPOINTS 100

/*
int PLOT_CURSORNPOINTS;
float PLOT_CURSORPOINTS[PLOT_CURSORMAXPOINTS][2];
*/

#define MAXDATAPOINTS 10000


/* Prototypes of user-callable functions */

void    plotcon(float zmat[], float xc[], int nx, float yc[], int ny,
	    float min, float step, float max, int lnstyle[], int labint);
void    plotxye(float x[], float y[], float e[], int npnt);
void    plot3d(float zmat[], float xlow, float xup, int nx, float ylow,
	    float yup, int ny);
void    my_cpgenv(float xmin, float xmax, float ymin, float ymax, 
		  int just, int axis);

void plot_blankpage(void);
void pushconfig(void);
void popconfig(void);
void getPlotcursorPoint(int point_no, int direction, float *coordinate);

#endif /* _PGMYPLOT_H_ */







